Lua_AwakePanel = class("Lua_AwakePanel", Lua_DisplayObject);
function Lua_AwakePanel:ctor(p)
	self:superCall("ctor", p, "AwakePanel_skin");
end

function Lua_AwakePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.index = 1;
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(126004));
	self.upBtn.label = LanUtil.getValue(126005);
	self.leftredDot:setEnable(false);
	self.rightredDot:setEnable(false);

	self.circleDic = {self.circle_01, self.circle_02, self.circle_03, self.circle_04, self.circle_05,
		self.circle_06, self.circle_07, self.circle_08, self.circle_09, self.circle_10};

	self.stripDic = {self.strip_01, self.strip_02, self.strip_03, self.strip_04, self.strip_05,
		self.strip_06, self.strip_07, self.strip_08, self.strip_09};

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum.numWidth = 11;
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(280, 239, 0);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(6);
	self.itemImg:setLocation(269.5, -144.5, 0);

	self.isAutomatic = true;
	self.arr = Array();
	for i = 1, 2 do
		self.obj = UICreate.createGameObject(self.content, -351 + (i - 1) * 130, -248, 0);
		self.skilldi = UICreate.createUIAtlasImage(self.obj, "common_atlas_1", "ui_common_icon_jnk_d", 0, 0, 0, 0);
		self.skilldi:setDepth(7);

		self.skill = UICreate.createUIAtlasImage(self.obj, "", "", 0, 0, 0, 0);
		self.skill.name = i;
		self.skill:setDepth(7);
		self.skill:addClickFuntion(self, self.skillClick);

		self.arr:add(self.skill);
	end

	-- 觉醒幻化功能屏蔽判断
	self.unrealRedDot:setEnable(false);
	if DataCenter.funcOpenData:isOpened(10156) then
		self:updateRedDot();
		self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);

		self.unrealBtn:setEnable(true);
		self.unrealBtn:addClickFuntion(self, self.onOpenWindowBtnClick)
	else
		self.unrealBtn:setEnable(false);
	end

	self.prevBtn:addClickFuntion(self, self.prevBtnClick);
	self.nextBtn:addClickFuntion(self, self.nextBtnClick);
	self.changeBtn:addClickFuntion(self, self.onChangeClick);
	self.autoUpBtn:addClickFuntion(self, self.automaticBtnClick);
	self.upBtn:addClickFuntion(self, self.oneBtnClick);

	self:addLuaEvent("OPENAWAKEINFO_UPDATE", self, self.upAwakeInfo);
	Lua_ProxyManager.getProxy("Lua_AwakeProxy"):sgetAwakeInfo();
end

-- 更新红点
function Lua_AwakePanel:updateRedDot()
	self.unrealRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(13004));
end

function Lua_AwakePanel:upAwakeInfo()
	local awakeData = DataCenter.awakeData;
	self.fightNum.num = awakeData.force;
	self.levelTxt.text = Lua_AwakeUtil:lvlConversion(awakeData.level);

	for k,v in pairs(self.stripDic) do
		if awakeData.level % 10 >= k then
			self.circleDic[k]:setAltas("awake_atlas", "ui_juexing_xing");
			self.stripDic[k]:setAltas("awake_atlas", "ui_juexing_xian2");
		else
			self.circleDic[k]:setAltas("awake_atlas", "ui_juexing_xing2");
			self.stripDic[k]:setAltas("awake_atlas", "ui_juexing_xian");
		end
	end
	self.circleDic[awakeData.level % 10 + 1]:setAltas("awake_atlas", "ui_juexing_xing3");

	local awakeLvDic = Lua_AwakeUtil:showrder();
	for i = 1, #Lua_AwakeUtil:modelHead() do
		if awakeLvDic[i] == math.floor(awakeData.level / 10) then
			self.circleDic[10]:setAltas("icon_atlas_2", Lua_AwakeUtil:modelHead()[i]);
			self.circleDic[10]:SetDimensions(58, 65);
		end
	end

	local itemNum = DataCenter.packData:getBagType(2):getItemNum(awakeData.needid[1]);
	self.itemImg.data = Lua_ToolVo.new(tonumber(awakeData.needid[1]), awakeData.needid[2], 0);
	self.itemImg:showNumLimit(itemNum, awakeData.needid[2], 2);

	self.leftredDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(13001))
	self.rightredDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(13001))

	self.bloodTxt.text = Lua_AwakeUtil:bloodDefine(awakeData.total_prop_list)
	self.attackTxt.text = Lua_AwakeUtil:attackDefine(awakeData.total_prop_list)
	self.defenceTxt.text = Lua_AwakeUtil:defenceDefine(awakeData.total_prop_list)

	if Lua_AwakeUtil:addBloodProperty(awakeData.level) ~= 0 then
		self.increaseBloodTxt.text = "+"..Lua_AwakeUtil:addBloodProperty(awakeData.level)
		self.increaseAttackTxt.text = "+"..Lua_AwakeUtil:addAttackProperty(awakeData.level)
		self.increaseDefenceTxt.text = "+"..Lua_AwakeUtil:addDefenceProperty(awakeData.level)

		LuaUtil.setObjPos(self.increaseAttackObj, self.attackTxt.mainContent.transform.localPosition.x + self.attackTxt.width + 61.5, 0, 0);
		LuaUtil.setObjPos(self.increaseBloodObj, self.bloodTxt.mainContent.transform.localPosition.x + self.bloodTxt.width + 61.5, 0, 0);
		LuaUtil.setObjPos(self.increaseDefenceObj, self.defenceTxt.mainContent.transform.localPosition.x + self.defenceTxt.width + 61.5, 0, 0);
		self.expBar:setText(awakeData.progress .. "/" .. awakeData.progress_max);
	else
		self.increaseAttackObj:SetActive(false);
		self.increaseBloodObj:SetActive(false);
		self.increaseDefenceObj:SetActive(false);
		self.expBar:setText("MAX" .. "(" .. awakeData.progress_max - awakeData.progress .. ")");

		for k, v in pairs(self.stripDic) do
			self.circleDic[k]:setAltas("awake_atlas", "ui_juexing_xing");
			self.stripDic[k]:setAltas("awake_atlas", "ui_juexing_xian2");
		end
		self.circleDic[10]:setAltas("awake_atlas", "ui_juexing_xing");
	end
	self.expBar:setMaxValue(awakeData.progress_max);
	self.expBar:setValue(awakeData.progress);

	self.modelId = Lua_AwakeUtil:awakeModelId();
	for i = 1, #self.modelId do
		if awakeData.cur_model_id == self.modelId[i] then
			self.index = i;
		end
		if awakeData.cur_model_id == 0 then
			self.cur_model_id = 0;
		end
		if awakeData.cur_model_id ~= self.cur_model_id and self.index ~= 1 and self.cur_model_id ~= nil then
			self:getModeWindow();
			return;
		end
	end
	self.cur_model_id = awakeData.cur_model_id;

	if self.show_id ~= awakeData.show_id then
		for i = 1, 3 do -- #self.modelId 只有前三个
			if self.modelId[i] == awakeData.show_id then
				self.index = i;
				break;
			end
		end
	end
	self.show_id = awakeData.show_id;

	self:showAwakeModel();
end

function Lua_AwakePanel:prevBtnClick(go)
	self.index = self.index - 1;
	if self.index < 1 then
		self.index = 1;
	end
	self:showAwakeModel();
end

function Lua_AwakePanel:nextBtnClick(go)
	self.index = self.index + 1;
	if self.index > 3 then
		self.index = 3;
	end
	self:showAwakeModel();
end

function Lua_AwakePanel:showAwakeModel()
	self.curLv = Lua_AwakeUtil:showrder()[self.index];
	local isLv = DataCenter.awakeData.level / 10 + 1 >= self.curLv;
	local isCurShowId = DataCenter.awakeData.show_id == self.modelId[self.index];
	self.changedObj:SetActive(isLv and isCurShowId);
	self.changeBtn:setEnable(isLv and not isCurShowId);
	
	if self.showModelIndex == self.index then
		return;
	end
	self.showModelIndex = self.index;

	self.nameTxt.text = Lua_AwakeUtil:clientNameShow(self.modelId[self.index]);

	local shapeConfig = getConfig({"playerHanger", tonumber(Lua_AwakeUtil:modelName(self.index))});
	if shapeConfig == nil then
		shapeConfig = getConfig({"playerHanger", tostring(Lua_AwakeUtil:modelName(self.index))});
	end
	if shapeConfig ~= nil then
		self.floder = shapeConfig.floder;
		self.fileName = shapeConfig.fileName;
		self.modelName = shapeConfig.modelName;
	end

	local imgPos = Vector2(-175, -34);
	local imgSize = Vector2(1175, 680);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(-265, -250);
	local modelpos = Lua_AwakeUtil:modelpos(self.modelId[self.index]);
	local modelros = Lua_AwakeUtil:modelros(self.modelId[self.index]);
	local modelsca = Lua_AwakeUtil:modelsca(self.modelId[self.index]);

	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
	end
	self.modelEffect = UIModelTexture();
	self.modelEffect:init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 160);
	self.modelEffect:setRotEnable(true, -137, 97, 400, 400, 2);
	if getCVersion() >= 1180 then
		self.modelEffect:setModelOffset(modelpos[1], modelpos[2], modelpos[3]);
	else
		self.modelEffect:setModelOffset(modelpos[1], modelpos[2]);
	end
	self.modelEffect:setModelAngle(modelros[1], modelros[2], modelros[3]);
	self.modelEffect:setCamView(15);
	self.modelEffect:setUrl(self.floder .. "/" .. self.fileName, self.fileName);
	self.modelEffect.uiEffect:setSacle(modelsca[1], modelsca[2], modelsca[3]);
	
	local showRder = Lua_CommonUtil.transChineseNumber(self.curLv);
	self.openStateLab.text = LanUtil.formateStr(LanUtil.getValue(126003), tostring(showRder));
	self.openStateLab:setEnable(not isLv);

	self.skillidDic = Lua_AwakeUtil:clientSkillhow(self.modelId[self.index]);
	for i = 1, #self.skillidDic.skill do
		self.arr[i]:setAltas(self.skillidDic.atlas[i], tostring(self.skillidDic.skill[i]));
	end

	if self.index <= 1 then
		self.prevBtn:setAltas("common_atlas_2", "ui_common_jiantou_02");
		self.prevBtn:removeClickFuntion(self, self.prevBtnClick);

		self.nextBtn:addClickFuntion(self, self.nextBtnClick);
	elseif self.index >= 3 then
		self.prevBtn:addClickFuntion(self, self.prevBtnClick);

		self.nextBtn:setAltas("common_atlas_2", "ui_common_jiantou_02");
		self.nextBtn:removeClickFuntion(self, self.nextBtnClick);
	else
		self.prevBtn:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.prevBtn:addClickFuntion(self, self.prevBtnClick);

		self.nextBtn:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.nextBtn:addClickFuntion(self, self.nextBtnClick);
	end
end

function Lua_AwakePanel:getModeWindow()
	local shapeConfig = getConfig({"playerHanger"});
	local configInfo;
	local data = {};
	for k, v in pairs(self.modelId) do
		if self.index == k then
			configInfo = shapeConfig[Lua_AwakeUtil:modelName(k)];
			if configInfo ~= nil then
				data.floder = configInfo.floder;
				data.fileName = configInfo.fileName;
				data.modelName = configInfo.modelName;
				data.cur_model_id = DataCenter.awakeData.cur_model_id
			end
		end
	end
	Lua_WindowUtil.openWin("Lua_OpenSeventDayModelPanel", WinParam.ACTION_OPEN, data);
	Lua_WindowUtil.openWin("Lua_AwakeWindow", WinParam.ACTION_CLOSE);
	return;
end

function Lua_AwakePanel:onOpenWindowBtnClick(go)
	Lua_WindowUtil.openWin("Lua_AwakeUnrealWindow")
end

function Lua_AwakePanel:onChangeClick(go)
	Lua_ProxyManager.getProxy("Lua_AwakeProxy"):sChangeAwakeModel(self.curLv);
end

function Lua_AwakePanel:automaticBtnClick(go)
	if self.isAutomatic then
		if Lua_AwakeUtil:addBloodProperty(DataCenter.awakeData.level) == 0 then
			OperateAlert.show(LanUtil.getValue(110033));
			return;
		end
		self.isAutomatic = false;
		self.prevBtn:removeClickFuntion(self, self.prevBtnClick);
		self.nextBtn:removeClickFuntion(self, self.nextBtnClick);
		self.unrealBtn:removeClickFuntion(self, self.onOpenWindowBtnClick);

		self.autoUpBtn.label = LanUtil.getValue(126001);
		Lua_CommonUtil.addTimer("Lua_AwakePanel", 0.1, self, self.oneBtnClick);
	else
		self.isAutomatic = true;
		self.prevBtn:addClickFuntion(self, self.prevBtnClick);
		self.nextBtn:addClickFuntion(self, self.nextBtnClick);
		self.unrealBtn:addClickFuntion(self, self.onOpenWindowBtnClick);

		self.autoUpBtn.label = LanUtil.getValue(126000);
		Lua_CommonUtil.removeTimer(self, self.oneBtnClick);
	end
end

function Lua_AwakePanel:oneBtnClick(go)
	local isAutomatic = true;
	local awakeData = DataCenter.awakeData;
	if Lua_AwakeUtil:addBloodProperty(awakeData.level) == 0 then
		OperateAlert.show(LanUtil.getValue(110033));
		return;
	end

	if DataCenter.packData:getBagType(2):getItemNum(awakeData.needid[1]) < awakeData.needid[2] then
		local arr = Array();
		arr:add(Lua_ToolVo.new(awakeData.needid[1], 1, 1));
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr)
		isAutomatic = false;
	end

	if isAutomatic == false then
		self.isAutomatic = true;
		self.prevBtn:addClickFuntion(self, self.prevBtnClick);
		self.unrealBtn:addClickFuntion(self, self.onOpenWindowBtnClick);
		self.nextBtn:addClickFuntion(self, self.nextBtnClick);

		self.autoUpBtn.label = LanUtil.getValue(126000);
		Lua_CommonUtil.removeTimer(self, self.oneBtnClick);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_AwakeProxy"):sAdvancedg();
end

function Lua_AwakePanel:skillClick(go)
	local skillidDic = {};
	for i = 1, #self.skillidDic.skill do
		skillidDic[i] = self.skillidDic.skill[i];
	end

	local limittype;
	local skillVo = Lua_SkillVo.new(skillidDic[tonumber(go.name)]);
	if skillVo.skillType == 1 then
		limittype = LanUtil.getValue(110600);
	elseif skillVo.skillType > 1 then
		limittype = LanUtil.getValue(110601);
	end
	Lua_WindowUtil.openWin("Lua_AwakeSkillTipsWindow", nil, {name = skillVo.name,
		skillIcon = skillidDic[tonumber(go.name)], atlas = skillVo.atlas, desc = skillVo.des,
		limittype = limittype, cool = LanUtil.formateStr(LanUtil.getValue(110612), tostring(skillVo.cool))});
end

function Lua_AwakePanel:dispose()
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	if self.arr ~= nil then
		self.arr:dispose();
		self.arr:clear();
		self.arr = nil;
	end
	if self.modelEffect ~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.oneBtnClick);

	self:superCall("dispose");
end