checkRequire("Lua_AwakeRecastSkillItem")
checkRequire("Lua_UpdataAwakeRemoldPanel")
checkRequire("Lua_AwakeChipItem")
Lua_AwakeRemoldPanel = class("Lua_AwakeRemoldPanel", Lua_DisplayObject);
function Lua_AwakeRemoldPanel:ctor(p)
	self:superCall("ctor", p, "AwakeRemoldPanel_skin");
end

function Lua_AwakeRemoldPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.plaintTxt.text = LanUtil.getValue(126048);
	self.strengthenTitleTxt.text = LanUtil.getValue(126049);

	DataCenter.awakeRecastUtil.selectIndex = 1;
	DataCenter.awakeRecastUtil.setSelectIragment = 1; --默认选择碎片

	self.btnList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 286, 595));
	self.btnList:setLocation(-456, -24, 0);
	self.btnList:setListCell(Lua_AwakeRemoldItem, 130, 286, 1);
	
	local item;
	self.itemList = {{-47.5, 225}, {76.5, 121}, {35.5, -17}, {-131.5, -17}, {-172.5, 121}};
	self.chipItemArr = Array();
	for i = 1, 5 do
		item = Lua_AwakeChipItem.new(self.content);
		item.content.name = "Lua_AwakeChipItem"..i;
		item:setDepth(4);
		item:setLocation(self.itemList[i][1], self.itemList[i][2], 0);
		self.chipItemArr:add(item);
	end
	
	self.skillPosList = {{-214, -164}, {-103, -164}, {8, -164}, {119, -164}, {-214, -236}, {-103, -236}, {8, -235}, {119, -236}};
	self.skillItemArr = Array();
	for i = 1, 8 do
		item = Lua_AwakeRecastSkillItem.new(self.content);
		item.content.name = "Lua_AwakeRecastSkillItem"..i;
		item:setDepth(4);
		item:setLocation(self.skillPosList[i][1], self.skillPosList[i][2], 0);
		self.skillItemArr:add(item);
	end

	self.awakeRemoldPanel = Lua_UpdataAwakeRemoldPanel.new(self.content);

	self.help:addClickFuntion(self, self.onHelp);

	self:updateRemoldPanel();

	self:addLuaEvent("UPDATE_UNREAL_INFO", self, self.updateRemoldPanel);
	self:addLuaEvent("UPDATE_SELECT_ITEM", self, self.setSelected);
	self:addLuaEvent("UPDATE_AWAKEREMOL", self, self.upDataItemInfo);
	sendMsg(11405201);
end

function Lua_AwakeRemoldPanel:updateRemoldPanel()
	self.selectIndex = DataCenter.awakeRecastUtil.selectIndex;
	
	local arr = DataCenter.awakeRecastUtil.recastUnrealInfo;
	self.btnList:setLuaArrayData(arr, false);
	self.btnList:setSelected(DataCenter.awakeRecastUtil.selectIndex);
	
	self:setSelected(DataCenter.awakeRecastUtil.selectIndex);
end

function Lua_AwakeRemoldPanel:setSelected(selectIndex)
	if self.selectIndex ~= selectIndex then
		DataCenter.awakeRecastUtil.setSelectIragment = 1;
	end
	self.selectIndex = selectIndex;

	local recastInfo = DataCenter.awakeRecastUtil.recastUnrealInfo[self.selectIndex];
	local len = recastInfo.getRecastIragment:getSize();
	for i = 1, len do
		self.chipItemArr[i]:setData(recastInfo.getRecastIragment[i]);
	end

	len = recastInfo.skillInfo:getSize();
	for i = 1, len do
		self.skillItemArr[i]:skillSetGray(not recastInfo.skillInfo[i].isEnable);
		self.skillItemArr[i]:skillSetEnable(true);
		self.skillItemArr[i]:setData(recastInfo.skillInfo[i]);
	end

	local setSelected = DataCenter.awakeRecastUtil.setSelectIragment;
	self:upDataItemInfo(recastInfo.getRecastIragment[setSelected]);
end

function Lua_AwakeRemoldPanel:upDataItemInfo(data)
	for i = 1, 5 do
		self.chipItemArr[i].selectIcon:setEnable(data.index == i);
	end
	self.awakeRemoldPanel:updateItemInfo(data);
end

function Lua_AwakeRemoldPanel:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(122266));
end

function Lua_AwakeRemoldPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.chipItemArr ~= nil then
		self.chipItemArr:dispose();
		self.chipItemArr:clear();
		self.chipItemArr = nil;
	end
	if self.skillItemArr ~= nil then
		self.skillItemArr:dispose();
		self.skillItemArr:clear();
		self.skillItemArr = nil;
	end
	if self.awakeRemoldPanel ~= nil then
		self.awakeRemoldPanel:dispose();
		self.awakeRemoldPanel = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_AwakeRemoldItem = class("Lua_AwakeRemoldItem", Lua_ListCell);
function Lua_AwakeRemoldItem:ctor(p)
	self:superCall("ctor", p, "AwakeRemoldItem_skin");
end

function Lua_AwakeRemoldItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AwakeRemoldItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.icon:setAltas(data.model_icon[1], data.model_icon[2]);
	self.iconBg:setAltas("common_atlas_1", "ui_common_prop_".. data.config.color + 1);

	self.nameLab.text = data.modelName;
	self.remoldLab.text = LanUtil.formateStr(LanUtil.getValue(126043), tostring(data.recastMinimumNum));   
	if data.level == 0 then
		self.icon:setGray(true);
		self.iconBg:setGray(true);
		self.remoldLab.text = "";
	else
		self.icon:setGray(false);
		self.iconBg:setGray(false);
	end
	
	self.unrealObj:SetActive(data.level > 0 and data.model_flag == 1);
	self.redDot:setEnable(data.isRedDot);
end

function Lua_AwakeRemoldItem:onPlayerSoundClick(go)
	DataCenter.awakeRecastUtil.selectIndex = self.data.index;
	Lua_MsgUtil.callFunc("UPDATE_SELECT_ITEM", self.data.index);
end

function Lua_AwakeRemoldItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end