checkRequire("Lua_AwakeTaskItem");
checkRequire("Lua_AwakeTaskUtil");
Lua_AwakeTaskWindow = class("Lua_AwakeTaskWindow", Lua_SecondSizeWindow)
function Lua_AwakeTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AwakeTaskWindow";
	self.skinName = "AwakeTaskWindow_skin";
	self.titleText = LanUtil.getValue(126056);
end

function Lua_AwakeTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isInfo = true;
	self.taskRole:SetActive(false);

	self.debrisDic = {self.debris_1, self.debris_2, self.debris_3, self.debris_4, self.debris_5};
	self.debrisDic0 = {self.debris_01, self.debris_02, self.debris_03, self.debris_04, self.debris_05};
	for i,v in ipairs(self.debrisDic) do
		self.debrisDic[i].name = i;
		self.debrisDic[i]:addClickFuntion(self, self.onDebrisClick)
	end

	self.dragList = Lua_DragList.new(self.content,1, Vector4(0, 0, 563, 319.5));
	self.dragList:setListCell(Lua_AwakeTaskItem, 123, 563, 1);
	self.dragList:setLocation(249, -120, 0);

	self.switch:addClickFuntion(self, self.onSwitchClick);

	self:addTimer("Lua_AwakeTaskWindow", 0.3, self, self.onEnterFrame);

	self:addLuaEvent("AWAKETASK_INFO", self, self.upAwakeTaskInfo);  
	self:addLuaEvent("UPDATA_ENDTIME", self, self.upAwakeTaskEndTime);
	sendMsg(11405211);
end

function Lua_AwakeTaskWindow:upAwakeTaskInfo(msg)
	self.msgInfo = msg;
	self.awakeStage = Lua_AwakeTaskUtil:stageData(msg.cur_step); -- 当前进行阶段
	self.tipsName:setAltas(self.awakeStage.name_icon[1], self.awakeStage.name_icon[2]);
	self.tipsName:resetSize();
	self.awakeHeadIcon:setAltas("icon_atlas_2", self.awakeStage.setAltas);

	self.awakeTaskArr = Lua_AwakeTaskUtil:awakeTaskList(msg.cur_step);
	local data;
	local arr = Array();
	for i,v in ipairs(msg.task_info) do
		if v.draw_state == 1 then
			self.debrisDic[i].color = Color.New(1, 1, 1, 1);
			self.debrisDic0[i]:setAltas("awake_atlas", "ui_juexing_icon_djk_01");
		else
			self.debrisDic[i].color = Color.New(0, 1, 1, 1);
			self.debrisDic0[i]:setAltas("awake_atlas", "ui_juexing_icon_djk_02");
		end
		self.debrisDic[i]:setAltas("awake_atlas", self.awakeTaskArr[i].item_id.."_"..i);

		arr:add({
			index = i,
			val = v.val,
			task_id = v.task_id,
			type = v.type,
			complete = v.complete,
			sortIndex = v.draw_state == 1 and i + 10 or i,
			draw_state = v.draw_state,
			value = self.awakeTaskArr[i]
		});
	end
	arr:sort("sortIndex", false);
	self.dragList:setLuaArrayData(arr, false);

	self.name.text = self.awakeStage.desc;
	self.skillTipsLab.text = self.awakeStage.skill_desc;

	self.leftTime = msg.end_time;
	self:onEnterFrame();

	if self.cur_step ~= msg.cur_step then
		self.cur_step = msg.cur_step;
		self:model();
	end
end

function Lua_AwakeTaskWindow:model()
	local config = Lua_AwakeTaskUtil:getConfig(self.msgInfo.cur_step)
	if self.modelEffect == nil then
		local imgPos = Vector2(-270, -87);
		local imgSize = Vector2(1175, 680);
		local modelRot = Vector3(0, 150, 0);
		local modelOffset = Vector2(-265, -250);

		self.modelEffect = UIModelTexture();
		self.modelEffect:init(self.taskRole, imgPos, imgSize, 3, modelRot, modelOffset, 160);               
		self.modelEffect:setRotEnable(true, 0, 0, 400, 400, 2)
	end
	self.modelEffect:setModelAngle(self.awakeStage.modelros[1], self.awakeStage.modelros[2], self.awakeStage.modelros[3]);
	self.modelEffect:setModelOffset(self.awakeStage.modelpos[1], self.awakeStage.modelpos[2], self.awakeStage.modelpos[3]);
	self.modelEffect:setCamView(15);
	self.modelEffect.uiEffect:setSacle(self.awakeStage.modelsca[1], self.awakeStage.modelsca[2], self.awakeStage.modelsca[3]);
	self.modelEffect:setUrl(config.floder.."/"..config.fileName, config.modelName)
end

function Lua_AwakeTaskWindow:onEnterFrame()
	if self.leftTime ~= nil then
		local lt = self.leftTime - tonumber(tostring(GlobalVar.cur_tick));
		if lt <= 0 then
			lt = 0;
		end
		self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(126025), TimeTransform.getInstance():transSeconds1(lt, true));
	end
end

function Lua_AwakeTaskWindow:upAwakeTaskEndTime(msg)
	self.leftTime = msg.end_time;
end

function Lua_AwakeTaskWindow:onDebrisClick(go)
	local index = tonumber(go.name)
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self.awakeTaskArr[index].item_id), false)
end

function Lua_AwakeTaskWindow:onSwitchClick()
	self.isInfo = not self.isInfo;
	self.taskInfo:SetActive(self.isInfo);
	self.taskRole:SetActive(not self.isInfo);
end

function Lua_AwakeTaskWindow:dispose()
	if self.modelEffect~= nil then
		self.modelEffect:dispose();
		self.modelEffect = nil;
	end

	self:superCall("dispose")
end