-- 觉醒幻化
checkRequire("Lua_CipeItem");
checkRequire("Lua_UnrealSkillItem");
Lua_AwakeUnrealWindow = class("Lua_AwakeUnrealWindow", Lua_SecondSizeWindow)
function Lua_AwakeUnrealWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AwakeUnrealWindow";
	self.skinName = "AwakeUnrealWindow_skin";
	self.titleText = LanUtil.getValue(126010);
end

function Lua_AwakeUnrealWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.red:setEnable(false);
	self.subBtn:setEnable(false);
	self.max_lab:setEnable(false);

	self.textArea = Lua_TextArea.new(self.content, 275, 170);
	self.textArea.insideItem.label.fontSize = 22;
	self.textArea.insideItem.label.spacingY = 4;
	self.textArea:setLocation(277, 131, 0);

	local item;
	self.itemArr = Array();
	for i = 1, 5 do
		item = Lua_CipeItem.new(self.content); -- 左槽
		item:setDepth(5);
		item:setCanClick(true);
		item:setCipeNnmetype(i); -- 卡牌名字编号
		item:setLocation(-281 + i * 94, -217.5, 0);
		self.itemArr:add(item);
	end

	self.skillArr = Array();
	for i = 1, 3 do
		item = Lua_UnrealSkillItem.new(self.content); -- 技能图标
		item.content.name = "Lua_UnrealSkillItem" .. i;
		item:setLocation(216 + i * 94, -147, 0);
		item:setCanClick(true);
		self.skillArr:add(item);
	end

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.prefix = "";
	self.fightNum.num = 0;
	self.fightNum.numWidth = 12;
	self.fightNum:setDepth(6);
	self.fightNum:setLocation(423, 217.5, 0);

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setLocation(404,-154,0);

	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(3, 0, 292, 542));
	self.recordsList:setLocation(-406, -30.5, 0);
	self.recordsList:setListCell(Lua_AwakeUnrealItem, 129, 286, 1);

	self.commonBtn:addClickFuntion(self, self.onCommonBtnClick); -- 幻化
	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick); -- 取消幻化
	self.subBtn:addClickFuntion(self, self.onSubBtnClick); -- 激活进阶

	self:addLuaEvent("UPDATE_SELECT_ITEM", self, self.onUpSelectItemClick); -- 点击Item
	self:addLuaEvent("SELECT_CHIP_ITEM", self, self.onUpSelectChipClick); -- 点击碎片
	self:addLuaEvent("UPDATE_UNREAL_INFO", self, self.updateUnrealPanel); -- 更新背包数据
	Lua_ProxyManager.getProxy("Lua_AwakeUnrealProxy"):sAwakeUnrealInfo();
end

function Lua_AwakeUnrealWindow:showWin(param)
	self:superCall("showWin", param);
	
	if type(param) == "table" and param.openIdx ~= nil then
		self.openIdx = param.openIdx;
	elseif type(param) == "number" then
		self.openIdx = param;
	end
end

function Lua_AwakeUnrealWindow:updateUnrealPanel()
	local selectIdx;
	if self.isFirst ~= true then
		self.isFirst = true;
		selectIdx = self.openIdx ~= nil and self.openIdx or 1;
	else
		selectIdx = DataCenter.awakeUnrealData.select_index;
	end
	self.recordsList:setLuaArrayData(DataCenter.awakeUnrealData.getArrByAwakeUnrealInfo, false);
	self.recordsList:setSelected(selectIdx);
	self.recordsList.showList[selectIdx]:onPlayerSoundClick();
end

function Lua_AwakeUnrealWindow:onUpSelectItemClick(data) -- 选择Item
	self.data = data;

	self.next_text.text = data.getNextUnrealProp;
	self.fightNum.num = data.getForce;
	self.skill_lab.text = LanUtil.getValue(126018);

	self.image:setEnable(false);
	self.max_lab:setEnable(false);
	self.show_lab:setEnable(true);
	self.subBtn:setEnable(false);
	self.red:setEnable(false);
	self.commonBtn:setEnable(data.model_flag ~= 1);
	self.cancelBtn:setEnable(data.model_flag == 1);

	-- 技能
	local skillArr = data.getUnrealSkill;
	for i = 1, skillArr:getSize() do
		self.skillArr[i]:setEnable(true);
		self.skillArr[i]:setSkillType(skillArr[i])
	end

	for i = 1, data.chipVo:getSize() do
		self.itemArr[i]:setCipetype(data, data.chipVo[i]);
		self.itemArr[i].chip_select:setEnable(false);
	end

	-- 碎片
	local select_part = DataCenter.awakeUnrealData.select_part;
	if DataCenter.awakeUnrealData.select_state ~= true then
		if select_part ~= 0 then
			self.itemArr[select_part].chip_select:setEnable(true);
			self.itemArr[select_part]:onIconClick();
		else
			self.textArea:setText(data.getAttProp);
		end
	else
		self.textArea:setText(data.getAttProp);
	end

	if data.model_lvl == 0 then
		self.show_lab.text = LanUtil.getValue(126016);
	else
		self.show_lab.uiwidget.gameObject:SetActive(false);
	end
	self:showModel(); -- 创建模型
end

function Lua_AwakeUnrealWindow:showModel()
	local shapeConfig = getConfig({"playerHanger", tonumber(self.data.model_id)});
	if shapeConfig == nil then 
		shapeConfig = getConfig({"playerHanger", tostring(self.data.model_id)});
	end
	self.floder = shapeConfig.floder;
	self.fileName = shapeConfig.fileName;
	self.modelName = shapeConfig.modelName;

	if self._modelEffect ~= nil then
		self._modelEffect:dispose();
		self._modelEffect = nil;
	end

	local imgPos = Vector2(-18, 35);
	local imgSize = Vector2(1175, 680);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(-265, -250);
	local modelpos = self.data.modelpos;
	local modelros = self.data.modelros;
	local modelsca = self.data.modelsca;

	self._modelEffect = UIModelTexture();
	self._modelEffect:init(self.content,imgPos, imgSize, 12, modelRot, modelOffset, 160);
	self._modelEffect:setRotEnable(true, 0, 0, 300, 400, 2)
	self._modelEffect:setCamPos(10000, 0, 0);
	if getCVersion() >= 1180 then
		self._modelEffect:setModelOffset(modelpos[1], modelpos[2], modelpos[3]);
	else
		self._modelEffect:setModelOffset(modelpos[1], modelpos[2]);
	end
	self._modelEffect:setModelAngle(modelros[1], modelros[2], modelros[3]);
	self._modelEffect:setCamView(15);
	self._modelEffect.uiEffect:setSacle(modelsca[1], modelsca[2], modelsca[3])
	self._modelEffect:setUrl(self.floder.."/"..self.fileName, self.modelName)
end

-- 选择碎片
function Lua_AwakeUnrealWindow:onUpSelectChipClick(data)
	self.vo = data;

	if data.chip_lvl == 0 then
		self.skill_lab.text = LanUtil.getValue(126019);
	else
		self.skill_lab.text = LanUtil.getValue(126026);
	end

	-- 技能隐藏
	for i = 1, self.skillArr:getSize() do
		self.skillArr[i]:setEnable(false);
	end

	for i = 1, self.itemArr:getSize() do
		self.itemArr[i].chip_select:setEnable(i == data.chip_part);
	end

	if data.chip_lvl < self.data.getMaxLevel   then -- 未满级
		self.textArea:setText(self.data:genNextAttProp(data.chip_part));

		-- 激活碎片显示
		self.bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(data.id);
		self.useNum = self.data:getUpdateNum(data.chip_part,data.chip_lvl);
		self.image.data = data;
		self.image:showNumLimit(self.bagNum, self.useNum, 2);
		self.image:setEnable(true);

		-- 激活按钮
		if data.chip_lvl > 0 then
			self.subBtn.label = LanUtil.getValue(126021);
		else
			self.subBtn.label = LanUtil.getValue(126020);
		end

		self.max_lab:setEnable(false);
		self.show_lab:setEnable(false);
		self.subBtn:setEnable(true);
		self.red:setEnable(self.bagNum >= self.useNum);
	else -- 已满级
		self.textArea:setText(self.data:genNextAttProp(data.chip_part));
		
		-- 碎片隐藏
		self.image:setEnable(false);
		if self.image.num_txt ~= nil then
			self.image.num_txt:setEnable(false);
		end

		self.max_lab:setEnable(true);
		self.show_lab:setEnable(false);
		self.subBtn:setEnable(false);
		self.red:setEnable(false);
	end
end

-- 幻化
function Lua_AwakeUnrealWindow:onCommonBtnClick()
	if self.data.model_lvl == 0 then
		OperateAlert.show(LanUtil.getValue(126022));
		return;
	else
		if DataCenter.roleData:isTransing() then
			OperateAlert.show(LanUtil.getValue(126023));
			return;
		else
			Lua_ProxyManager.getProxy("Lua_AwakeUnrealProxy"):sAwakeUnreal(self.data.model_id, 1);
		end
	end
end

-- 取消幻化
function Lua_AwakeUnrealWindow:onCancelBtnClick()
	Lua_ProxyManager.getProxy("Lua_AwakeUnrealProxy"):sAwakeUnreal(self.data.model_id, 0);
end

-- 激活进阶
function Lua_AwakeUnrealWindow:onSubBtnClick()
	if self.bagNum >= self.useNum then
		Lua_ProxyManager.getProxy("Lua_AwakeUnrealProxy"):sChipUpdateActivate(self.data.model_id, self.vo.chip_part - 1);
	else
		local arr = Array();
		arr:add(self.vo);
		Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr)
	end
end

function Lua_AwakeUnrealWindow:dispose()
	if self.recordsList ~= nil then
		self.recordsList:dispose()
		self.recordsList = nil;
	end
	DataCenter.awakeUnrealData.select_part = 0;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_AwakeUnrealItem = class("Lua_AwakeUnrealItem", Lua_ListCell);
function Lua_AwakeUnrealItem:ctor(p)
	self:superCall("ctor", p, "AwakeUnrealItem_skin");
end

function Lua_AwakeUnrealItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.name.text = data.model_name;

	self.icon:setAltas(data.model_icon[1], data.model_icon[2]);
	self.icon_bg:setAltas("common_atlas_1", "ui_common_prop_"..(data.color + 1));

	self.icon:setGray(data.model_lvl == 0);
	self.icon_bg:setGray(data.model_lvl == 0);
	self.unrealObj:SetActive(data.model_lvl > 0 and data.model_flag == 1);
	self.red:setEnable(data.isShowUnrealRed);
end

function Lua_AwakeUnrealItem:onPlayerSoundClick(go)
	if self.cellSeqIndex == nil then return end
	
	DataCenter.awakeUnrealData.select_state = self.cellSeqIndex ~= DataCenter.awakeUnrealData.select_index;
	DataCenter.awakeUnrealData.select_index = self.cellSeqIndex;
	Lua_MsgUtil.callFunc("UPDATE_SELECT_ITEM", self._data);
end

function Lua_AwakeUnrealItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	
	if val then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x1");
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_x2");
	end
end