Lua_UpdataAwakeRemoldPanel = class("Lua_UpdataAwakeRemoldPanel", Lua_DisplayObject);
function Lua_UpdataAwakeRemoldPanel:ctor(p)  
	self:superCall("ctor", p, "UpdataRemoldPanel_skin");
end

function Lua_UpdataAwakeRemoldPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftredDot:setEnable(false);
	self.rightredDot:setEnable(false);
	self.breachRedDot:setEnable(false);
	self.trainLab.text = LanUtil.getValue(126050);
	
	self.primarySeleted = 0;
	self.recast_time = 0;
	self.barlist = {self.bloodBar, self.magicBar, self.expBar};
	self.barTxtlist = {self.bloodLab, self.magic, self.exp};

	local tvo = Lua_ToolVo.createToolVo(214000001);
	self.primaryMoneyIcon:setAltas(tvo.atlas, tvo.referenceId);
	local tvo = Lua_ToolVo.createToolVo(214000002);
	self.seniorMoneyIcon:setAltas(tvo.atlas, tvo.referenceId);

	self.recastBtn.label = LanUtil.getValue(126053);
	self.recastBtn:addClickFuntion(self, self.onRecastBtnClick);

	self.recastTenBtn.label = LanUtil.getValue(126054);
	self.recastTenBtn:addClickFuntion(self, self.onRecastTenBtnClick);

	self.primary.seleted = true;
	self.primary:addBoxChange(self, self.onPrimaryBoxClick);
	self.senior:addBoxChange(self, self.onSeniorBoxClick);

	self.breakItem = Lua_ToolImage.new(self.breakObj);
	self.breakItem:setDepth(5);
	self.breakItem:setLocation(357, -110, 0)
	self.breakBtn:addClickFuntion(self, self.onSendMsg);
end

function Lua_UpdataAwakeRemoldPanel:updateItemInfo(data)
	self.data = data;

	if data.debris_message == 0 or data.debris_message == nil then
		local textStr;
		for i,v in ipairs(data.property_upper) do
			self.barlist[i]:setMaxValue(0);
			self.barlist[i]:setPercent((0)/(0))
			self.barlist[i].txt:setEnable(true);
			self.barlist[i].txt.text = (0).. "/" .. (0);

			textStr = Lua_ThingDefine.getParamName(v[1])..":";
			textStr = string.gsub(textStr, "+{1}", "");
			self.barTxtlist[i].text = textStr;
		end
		self.trainObj:SetActive(false);
		self.maxedLab.text = LanUtil.getValue(126038);
	else
		if data.recastPropertyListMsg ~= nil then
			local textStr;
			for i,v in ipairs(data.recastPropertyListMsg.obj_list) do
				for k,j in ipairs(data.property_upper) do
					if tonumber(v.obj_id) == tonumber(j[1]) then
						self.barlist[i]:setMaxValue(j[2]);
						self.barlist[i]:setPercent(tonumber(v.obj_value) / tonumber(j[2]));
						self.barlist[i].txt:setEnable(true);
						self.barlist[i].txt.text = v.obj_value.. "/" .. j[2];

						textStr = Lua_ThingDefine.getParamName(j[1])..":";
						textStr = string.gsub(textStr, "+{1}", "");
						self.barTxtlist[i].text = textStr;
					end
				end
			end
		end
		self.trainObj:SetActive(true);
		self.maxedLab.text = "";
	end

	if data.is_break == 1 then
		self.trainObj:SetActive(false);
		self.breakObj:SetActive(true);
		if self.data.breakCostDic ~= nil then
			self.breakItem.data = Lua_ToolVo.new(tonumber(data.breakCostDic[1][1]), 0, 0); 
			self.breakItem:showNumLimit(data.getBreakCostCost,data.needBreakCostCost,2);
			self.condition.text = LanUtil.formateStr(LanUtil.getValue(126040), tostring(data.lvl_limite)); 
		end
	else
		self.breakObj:SetActive(false);
	end

	self.itemIcon:setAltas(data.altas, tostring(data.config.item_id));
	self.nameLab.text = data.recast_name;
	self.forceLab.text = LanUtil.formateStr(LanUtil.getValue(126036), tostring(data.recastForce));
	self.scheduleLab.text = LanUtil.formateStr(LanUtil.getValue(126037), tostring(data.recast_level.."/"..20))
	
	self.primaryMoneyTxt.text = data.getPrimaryCost.."/"..data.needPrimaryCost; 
	self.seniorMoneyTxt.text = data.getAdvancedCost.."/"..data.needAdvancedCost; 

	if data.isMaxLevel == true then
		self.trainObj:SetActive(false);
		self.breakObj:SetActive(false);
		self.maxedLab.text = LanUtil.getValue(126039);
	end
	self:updateRedDot();
end

function Lua_UpdataAwakeRemoldPanel:onPrimaryBoxClick()
	self.primary.seleted = true;
	self.senior.seleted = false;
	self.primarySeleted = 0;
	self:updateRedDot()
end

function Lua_UpdataAwakeRemoldPanel:onSeniorBoxClick()
	self.primary.seleted = false;
	self.senior.seleted = true;
	self.primarySeleted = 1;
	self:updateRedDot()
end

function Lua_UpdataAwakeRemoldPanel:onRecastBtnClick()
	self.recast_time = 0;
	self:onSendMsg();
	self:onPrimaryItemOutput();
end

function Lua_UpdataAwakeRemoldPanel:onRecastTenBtnClick()
	self.recast_time = 1;
	self:onSendMsg();
	self:onPrimaryItemOutput();
end

function Lua_UpdataAwakeRemoldPanel:onSendMsg()
	local cmd = ProtoPublic_pb.Proto11405204();
	cmd.model_id = self.data.modeleId;
	cmd.debris_id = self.data.index;
	cmd.recast_type = self.primarySeleted;
	cmd.recast_time = self.recast_time;
	cmd.is_break = self.data.is_break;
	sendMsg(11405204, cmd);
end

function Lua_UpdataAwakeRemoldPanel:onPrimaryItemOutput()
	if self.primarySeleted == 0 then
		if (self.data.needPrimaryCost > self.data.getPrimaryCost and self.recast_time == 0) 
			or (self.data.needPrimaryCost * 10 > self.data.getPrimaryCost and self.recast_time == 1) then
			local arr = Array();
			arr:add(Lua_ToolVo.new(self.data.primaryCostDic[1][1], 1, 1));
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr)
		end
	else
		if (self.data.needAdvancedCost > self.data.getAdvancedCost and self.recast_time == 0 ) 
			or (self.data.needAdvancedCost * 10 > self.data.getAdvancedCost and self.recast_time == 1 ) then
			local arr = Array(); 
			arr:add(Lua_ToolVo.new(self.data.advancedCostDic[2][1], 1, 1));
			Lua_WindowUtil.openWin("Lua_ItemOutputWindow", nil, arr)
		end
	end
end

function Lua_UpdataAwakeRemoldPanel:updateRedDot()
	self.leftredDot:setEnable(self.data.isOneBtnRedDot);
	self.rightredDot:setEnable(self.data.isTenBtnRedDot);
	self.breachRedDot:setEnable(self.data.isBreakBtnRedDot);
end