Lua_AwakeTaskItem = class("Lua_AwakeTaskItem", Lua_ListCell);
function Lua_AwakeTaskItem:ctor(p)
	self:superCall("ctor", p, "AwakeTaskItem_skin");
end

function Lua_AwakeTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
	self.headBg:addClickFuntion(self, self.onSelectClick)
end

function Lua_AwakeTaskItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.headIcon:setAltas("awake_atlas", tostring(data.value.item_id.."_"..data.index));

	local condition;
	if data.val == data.value.cond_value[1] then
		condition = "[FFFFFF]("..data.val.."/"..data.value.cond_value[1]..")[-]";
	else
		condition = "[FF1616]("..data.val.."/"..data.value.cond_value[1]..")[-]";
	end

	if data.value.task_type == 106 then
		condition = Lua_AwakeTaskUtil:textShow(data.val, data.value.cond_value[1]);
	end
	self.desLab.text = "[FFFFFF]"..data.value.desc.."[-]"..condition;

	if data.complete == 1 then
		self.stateBtn.label = LanUtil.getValue(127602);
		self.redDot:setEnable(true);
	else
		self.stateBtn.label = data.value.name;
		self.redDot:setEnable(false);
	end

	if data.draw_state == 1 then
		self.stateBtn:setEnable(false);
		self.receivedIcon:setEnable(true);
		self.redDot:setEnable(false)
	else
		self.stateBtn:setEnable(true);
		self.receivedIcon:setEnable(false);
	end
end

function Lua_AwakeTaskItem:onBtnClick()
	if self._data.complete == 1 then
		local cmd = ProtoPublic_pb.Proto11405212();
		cmd.task_id = self._data.task_id;
		sendMsg(11405212, cmd);
	else
		if self._data.value.task_type == 102
			and (DataCenter.roleData.leagueName == nil or DataCenter.roleData.leagueName == "") then
			OperateAlert.show(LanUtil.getValue(128410));
			return;
		end
		Lua_WindowUtil.openWin(self._data.value.window, nil, self._data.value.windowtab);
		Lua_WindowUtil.openWin("Lua_AwakeTaskWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_AwakeTaskItem:onSelectClick()
	Lua_PackUtil.showItemInfo(Lua_ToolVo.new(self._data.value.item_id), false);
end