-- 觉醒幻化碎片item
Lua_CipeItem = class("Lua_CipeItem", Lua_DisplayObject);
function Lua_CipeItem:ctor(p)
	self:superCall("ctor", p, "CipeItem_skin");
end

function Lua_CipeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.chip_bg.clickScale = false;
end

function Lua_CipeItem:setCipeNnmetype(val)
	local value = {"金", "木", "水", "火", "土"};
	self.cipeType = val;
	self.content.name = "Lua_CipeItem" .. val;
	self.chip_lab.text = value[val];
end

function Lua_CipeItem:setCipetype(data, tvo)
	self.data = data;
	self.tvo = tvo;

	local bagNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(tvo.id);
	local useNum = data:getUpdateNum(tvo.chip_part, tvo.chip_lvl);
	if tvo.chip_lvl == 0 then
		-- 未激活
		if bagNum >= useNum then
			self.chip_text.text = LanUtil.getValue(126012)
		else
			self.chip_text.text = LanUtil.getValue(126011)
		end
		self.chip_add.text = "+" .. tvo.chip_lvl;

		self.chip_icon:setEnable(false);
		self.chip_text:setEnable(true);
		self:showRedDot(bagNum >= useNum);
	else
		-- 已激活
		self.chip_icon:setAltas("awake_atlas", tvo.id .. "_" .. tvo.chip_part);
		self.chip_add.text = "+" .. tvo.chip_lvl;

		self.chip_icon:setEnable(true);
		self.chip_text:setEnable(false);
		self:showRedDot(tvo.chip_lvl < data.getMaxLevel and bagNum >= useNum);
	end
end

function Lua_CipeItem:setCanClick(val)
	if val then
		self.chip_bg.mouseEnable = true;
		self.chip_bg:addClickFuntion(self, self.onIconClick);
	else
		self.chip_bg.mouseEnable = false;
		self.chip_bg:removeClickFuntion(self, self.onIconClick);
	end
end

function Lua_CipeItem:setDepth(val)
	self:superCall("setDepth", val);

	self.chip_bg:setDepth(val);
	self.chip_icon:setDepth(val + 1);
	self.chip_select:setDepth(val + 2);
	self.chip_text:setDepth(val + 2);
	
	self.chip_yuan:setDepth(val + 3);
	self.chip_lab:setDepth(val + 4);

	self.chip_addbg:setDepth(val + 3);
	self.chip_add:setDepth(val + 4);
end

function Lua_CipeItem:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 36, 22, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(25);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_CipeItem:onIconClick(go)
	DataCenter.awakeUnrealData.select_part = self.tvo.chip_part;
	Lua_MsgUtil.callFunc("SELECT_CHIP_ITEM", self.tvo);
end

function Lua_CipeItem:dispose()
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end
	self:superCall("dispose");
end